// Written by TeTeT


ttt_maas_fnc_wires = {

	params ["_plane"];

	private ["_p1", "_p2", "_p3", "_p4", "_thPos", "_pointPlane",
			 "_d1", "_d2", "_d3", "_d4", "_cableA", "_cableB", "_cable",
			 "_animations"];

	_p1 = maas selectionPosition "wire1";
	_animations = [_p1, "ani_cable1_wide", "ani_cable1_long", "ani_cable1_high"];
	systemChat format ["_animations are %1", _animations];
	while {alive _plane} do {
		private ["_pointPlane", "_dWide", "_dLong", "_dHigh",
				 "_pointWire"];
		_pointWire = _animations select 0;

		_pointPlane = _wires worldToModel (_plane modelToWorld (_plane selectionPosition "tailhook"));
		_dWide = (_pointPlane select 0) - (_pointWire select 0);
		_dLong = (_pointPlane select 1) - (_pointWire select 1);
		_dHigh = (_pointPlane select 2) - (_pointWire select 2);

		_wires animate [_animations select 1, _dWide];
		_wires animate [_animations select 2, _dLong];
		_wires animate [_animations select 3, _dHigh];
		sleep 0.04;

		if (_plane animationPhase "tailhook" < 0.9) exitWith {
			_wires animate [_animations select 1, 0];
			_wires animate [_animations select 2, 0];
			_wires animate [_animations select 3, 0];
		};
	};
	systemChat "End of wire animation";
};

ttt_maas_fnc_useWires = {
	params ["_vehicleList", "_wires"];
	systemChat format ["Wires is %1", _wires];

	{
		if (_x isKindOf "Plane") then {
			systemChat "Plane approaching";

			if (getPosATL _x select 2 < 50 and _x animationPhase "tailhook" == 1) then {
				systemChat "plane possibly landing";

				waitUntil { ((getPosATL _x select 2) - (getPosATL _wires select 2)) < 0.2; };
				waitUntil { (_x distance _wires) < 10; };

				if ( (_x distance _wires) < 10 and (speed _x) < 250 ) then {
					systemChat "Touchdown, braking";
					[_x, _wires] spawn ttt_maas_fnc_wires;
					sleep 0.5;
					while {alive _x and speed _x > 0.1} do {
					 	private ["_vel"];
					 	_vel = velocity _x;
					 	_x setVelocity [(_vel select 0) * 0.7,
					 				    (_vel select 1) * 0.7,
					 				    (_vel select 2) * 0.7];
					    sleep 0.2;
					};

					waitUntil {_x setVelocity [0,0,-0.5]; _x animationPhase "tailhook" < 1};

				} else {
					systemChat "Abort";
				};
			};
		};
	} forEach _vehicleList;
};

ttt_maas_fnc_arrest = {
	systemChat "Establishing arresting wires";

	params [["_wires", ObjNull]];

	if (isNull _wires) exitWith { "MAAS: Need a wires object" call BIS_fnc_log; };
	ttt_maas_wires = _wires;
	private ["_trigger"];

	_trigger = createTrigger ["EmptyDetector", getPos _wires];
	_trigger setTriggerArea [100, 100, 100, false];
	_trigger setTriggerActivation ["WEST", "WEST D", true];
	_trigger setTriggerStatements ["this", "[thisList, ttt_maas_wires] spawn ttt_maas_fnc_useWires;", "hint 'trigger off'"];

	_trigger;
};